/*
 * CzDC - client for Direct Connect peer to peer network.

 * Copyright (C) 2002-2011 Petr Kozelka, PPK at CzDC dot org

 * CzDC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * CzDC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with CzDC. If not, see <http://www.gnu.org/licenses/>.
 */

//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#ifndef BASIC_SPLITTER_H
#define BASIC_SPLITTER_H
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#pragma once
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

class BasicSplitter {
public:
    BasicSplitter();
    ~BasicSplitter() { }

    bool BasicSplitterProc(UINT uMsg, WPARAM wParam, LPARAM lParam);

    void SetSplitterRect(const LPRECT &lpRect);
    void SetSplitterHorCursor();

    RECT rcSplitter;
    int iSplitterPos, iProportionalPos;
    bool bSplitterDisabled;
private:
    virtual HWND GetWindowHandle() = NULL;
    virtual void UpdateSplitterParts() = NULL;

	bool OnMouseMove(WPARAM wParam, LPARAM lParam);
	void OnLButtonDown(LPARAM lParam);
	void OnLButtonUp();

    void SetSplitterPosition(int iPos, const bool &bUpdate = true);
	bool IsCursorOverSplitter(const int &iX, const int &iY);

    bool bUpdateProportionalPos, bVertical;
    HCURSOR hCursor;
};
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

#endif
