/*
 * CzDC - client for Direct Connect peer to peer network.

 * Copyright (C) 2002-2011 Petr Kozelka, PPK at CzDC dot org

 * CzDC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * CzDC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with CzDC. If not, see <http://www.gnu.org/licenses/>.
 */

//----------------------------------------------------------------------------------------------------------------------------------------------------
#ifndef CzDCPage_H
#define CzDCPage_H
//----------------------------------------------------------------------------------------------------------------------------------------------------
#pragma once
//----------------------------------------------------------------------------------------------------------------------------------------------------
#include "PropPage.h"
//----------------------------------------------------------------------------------------------------------------------------------------------------
#include "../client/ConnectionManager.h"
//----------------------------------------------------------------------------------------------------------------------------------------------------

class CzDCPage : public PropPage {
public:
	CzDCPage(SettingsManager *s);
	~CzDCPage();

	void onInitDialog();
	void onBrowse();
	void onClickedProgressDown();
	void onClickedProgressUp();
	void onClickedProgressTextDown();
	void onClickedProgressTextUp();
	void onClickedWinampHelp();
	void onClearKickline();
	void onClearSearches();

	// Common PropPage interface
	PROPSHEETPAGE *getPSP() { return &m_psp; }
	void write();
private:
	static Item items[];
	static TextItem texts[];
	COLORREF crProgressDown;
	COLORREF crProgressUp;
	COLORREF crProgressTextDown;
	COLORREF crProgressTextUp;

    static BOOL CALLBACK CzDCPageProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
};
//----------------------------------------------------------------------------------------------------------------------------------------------------

#endif
