/*
 * CzDC - client for Direct Connect peer to peer network.

 * Copyright (C) 2002-2011 Petr Kozelka, PPK at CzDC dot org

 * CzDC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * CzDC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with CzDC. If not, see <http://www.gnu.org/licenses/>.
 */

//----------------------------------------------------------------------------------------------------------------------------------------------------
#include "stdafx.h"
//----------------------------------------------------------------------------------------------------------------------------------------------------
#include "../client/DCPlusPlus.h"
//----------------------------------------------------------------------------------------------------------------------------------------------------
#include "Resource.h"
//----------------------------------------------------------------------------------------------------------------------------------------------------
#include "ExpertPage.h"
#include "CommandDlg.h"
//----------------------------------------------------------------------------------------------------------------------------------------------------
#include "../client/SettingsManager.h"
#include "../client/FavoriteManager.h"
//----------------------------------------------------------------------------------------------------------------------------------------------------
#include "WinUtil.h"
//----------------------------------------------------------------------------------------------------------------------------------------------------

ExpertPage * pExpertPage = NULL;
//----------------------------------------------------------------------------------------------------------------------------------------------------

ExpertPage::ExpertPage(SettingsManager *s) : PropPage(s, IDD_EXPERT_PAGE) {
    pExpertPage = this;
	title = _tcsdup((TSTRING(SETTINGS_ADVANCED) + _T('\\') + TSTRING(SETTINGS_EXPERT)).c_str());
	SetTitle(title);
	m_psp.pfnDlgProc = (DLGPROC)ExpertPageProc;
}
//----------------------------------------------------------------------------------------------------------------------------------------------------

ExpertPage::~ExpertPage() {
    pExpertPage = NULL;
    free(title);
}
//----------------------------------------------------------------------------------------------------------------------------------------------------

BOOL CALLBACK ExpertPage::ExpertPageProc(HWND hWnd, UINT uMsg, WPARAM /*wParam*/, LPARAM /*lParam*/) {
    if(uMsg == WM_INITDIALOG) {
        pExpertPage->m_hWnd = hWnd;
        pExpertPage->onInitDialog();
        return TRUE;
    }

	return FALSE;
}
//----------------------------------------------------------------------------------------------------------------------------------------------------

PropPage::TextItem ExpertPage::texts[] = {
	{ IDC_SETTINGS_ADVANCED, ResourceManager::SETTINGS_ADVANCED_SETTINGS },
	{ IDC_SETTINGS_ROLLBACK, ResourceManager::SETTINGS_ROLLBACK },
	{ IDC_SETTINGS_B, ResourceManager::B },
	{ IDC_SETTINGS_WRITE_BUFFER, ResourceManager::SETTINGS_WRITE_BUFFER },
	{ IDC_SETTINGS_KB, ResourceManager::KB },
	{ IDC_SETTINGS_MAX_TAB_ROWS, ResourceManager::SETTINGS_MAX_TAB_ROWS },
	{ IDC_SETTINGS_MAX_HASH_SPEED, ResourceManager::SETTINGS_MAX_HASH_SPEED },
	{ IDC_SETTINGS_MBS, ResourceManager::MBPS },
	{ IDC_SETTINGS_MAX_FILELIST_SIZE, ResourceManager::SETTINGS_MAX_FILELIST_SIZE },
	{ IDC_SETTINGS_MB, ResourceManager::MB },
	{ IDC_SETTINGS_AUTO_REFRESH_TIME, ResourceManager::SETTINGS_AUTO_REFRESH_TIME },
	{ IDC_SETTINGS_AUTO_SEARCH_LIMIT, ResourceManager::SETTINGS_AUTO_SEARCH_LIMIT },
	{ IDC_SETTINGS_MAX_PMS, ResourceManager::SETTINGS_MAX_PMS },
	{ IDC_SETTINGS_MAX_TAB_TXT_LEN_TXT, ResourceManager::SETCZDC_TEXT_LEN_ON_TABS },
	{ 0, ResourceManager::SETTINGS_AUTO_AWAY }
};
//----------------------------------------------------------------------------------------------------------------------------------------------------

PropPage::Item ExpertPage::items[] = {
	{ IDC_ROLLBACK, SettingsManager::ROLLBACK, PropPage::T_INT }, 
	{ IDC_BUFFERSIZE, SettingsManager::BUFFER_SIZE, PropPage::T_INT },
	{ IDC_MAX_TAB_ROWS, SettingsManager::MAX_TAB_ROWS, PropPage::T_INT },
	{ IDC_MAX_HASH_SPEED, SettingsManager::MAX_HASH_SPEED, PropPage::T_INT },
	{ IDC_MAX_FILELIST_SIZE, SettingsManager::MAX_FILELIST_SIZE, PropPage::T_INT },
	{ IDC_SOCKET_IN_BUFFER, SettingsManager::SOCKET_IN_BUFFER, PropPage::T_INT },
	{ IDC_SOCKET_OUT_BUFFER, SettingsManager::SOCKET_OUT_BUFFER, PropPage::T_INT },
	{ IDC_AUTO_REFRESH_TIME, SettingsManager::AUTO_REFRESH_TIME, PropPage::T_INT },
	{ IDC_AUTO_SEARCH_LIMIT, SettingsManager::AUTO_SEARCH_LIMIT, PropPage::T_INT },
	{ IDC_MAX_PMS, SettingsManager::MAX_PMS, PropPage::T_INT }, 
	{ IDC_SETTINGS_MAX_TAB_TXT_LEN, SettingsManager::MAX_TAB_TXT_LEN, PropPage::T_INT }, 
	{ 0, 0, PropPage::T_END }
};
//----------------------------------------------------------------------------------------------------------------------------------------------------

void ExpertPage::onInitDialog() {
	PropPage::translate(m_hWnd, texts);
	PropPage::read(m_hWnd, items, 0, 0);
}
//----------------------------------------------------------------------------------------------------------------------------------------------------

void ExpertPage::write() {
	PropPage::write(m_hWnd, items, 0, 0);
}
//----------------------------------------------------------------------------------------------------------------------------------------------------
