/*
 * Copyright (C) 2001-2011 Jacek Sieka, arnetheduck on gmail point com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef HASH_PROGRESS_DLG_H
#define HASH_PROGRESS_DLG_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../client/HashManager.h"

class HashProgressDlg {
public:
	enum { WM_VERSIONDATA = WM_APP + 53 };

	HashProgressDlg(bool aAutoClose) : autoClose(aAutoClose), startTime(GET_TICK()), startBytes(0), startFiles(0), m_hWnd(NULL) { }
	~HashProgressDlg() { }

    static INT_PTR CALLBACK HashProgressDlgProc(HWND hWndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
    LRESULT HashProgressProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	void DoModal(HWND hWndParent);

    HWND m_hWnd;
private:
	void OnInitDialog();
	void onTimer();
	void onDestroy();
	void updateStats();
	void OnCloseCmd(WORD wID);

	bool autoClose;
	int64_t startBytes;
	size_t startFiles;
	uint64_t startTime;
};

#endif // HASH_PROGRESS_DLG_H

/*
 * Some parts Copyright (C) 2002-2011 Petr Kozelka, PPK at czdc dot org
 * Licensed under GNU General Public License version 3.
 */
