//
// Author : Hani Atassi  (atassi@arabteam2000.com)
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ImageDataObject.h"

CImageDataObject::CImageDataObject() : m_ulRefCnt(0), m_bRelease(FALSE) { }

CImageDataObject::~CImageDataObject() {
	if(m_bRelease == TRUE) {
		::ReleaseStgMedium(&m_stgmed);
	}
}

void CImageDataObject::SetBitmap(HBITMAP hBitmap) {
	STGMEDIUM stgm;
	stgm.tymed = TYMED_GDI;
	stgm.hBitmap = hBitmap;
	stgm.pUnkForRelease = NULL;

	FORMATETC fm;
	fm.cfFormat = CF_BITMAP;
	fm.ptd = NULL;
	fm.dwAspect = DVASPECT_CONTENT;
	fm.lindex = -1;
	fm.tymed = TYMED_GDI;

	this->SetData(&fm, &stgm, TRUE);		
}

IOleObject *CImageDataObject::GetOleObject(IOleClientSite *pOleClientSite, IStorage *pStorage) {
	IOleObject *pOleObject;

	if(::OleCreateStaticFromData(this, IID_IOleObject, OLERENDER_FORMAT, 
			&m_fromat, pOleClientSite, pStorage, (void **)&pOleObject) != S_OK) {
		return NULL;
	}

	return pOleObject;
}

HRESULT CImageDataObject::QueryInterface(REFIID iid, void ** ppvObject) {
	if(iid == IID_IUnknown || iid == IID_IDataObject) {
		*ppvObject = this;
		AddRef();
		return S_OK;
	} else
		return E_NOINTERFACE;
}

ULONG CImageDataObject::AddRef(void) {
	m_ulRefCnt++;
	return m_ulRefCnt;
}

ULONG CImageDataObject::Release(void) {
	if(--m_ulRefCnt == 0) {
		delete this;
		return 0;
	}

	return m_ulRefCnt;
}

HRESULT CImageDataObject::GetData(FORMATETC* /*pformatetcIn*/, STGMEDIUM *pmedium) {
	pmedium->tymed = TYMED_GDI;
	pmedium->hBitmap = m_stgmed.hBitmap;
	pmedium->pUnkForRelease = NULL;

	return S_OK;
}

HRESULT CImageDataObject::GetDataHere(FORMATETC* /*pformatetc*/, STGMEDIUM*  /*pmedium*/) {
	return E_NOTIMPL;
}

HRESULT CImageDataObject::QueryGetData(FORMATETC* /*pformatetc*/) {
	return E_NOTIMPL;
}

HRESULT CImageDataObject::GetCanonicalFormatEtc(FORMATETC* /*pformatectIn*/,FORMATETC* /*pformatetcOut*/) {
	return E_NOTIMPL;
}

HRESULT CImageDataObject::SetData(FORMATETC* pformatetc , STGMEDIUM*  pmedium , BOOL  fRelease ) {
	m_fromat = *pformatetc;
	m_stgmed = *pmedium;
	m_bRelease = fRelease;

	return S_OK;
}

HRESULT CImageDataObject::EnumFormatEtc(DWORD /*dwDirection*/, IEnumFORMATETC** /*ppenumFormatEtc*/) {
	return E_NOTIMPL;
}

HRESULT CImageDataObject::DAdvise(FORMATETC* /*pformatetc*/, DWORD /*advf*/, IAdviseSink* /*pAdvSink*/, DWORD* /*pdwConnection*/) {
	return E_NOTIMPL;
}

HRESULT CImageDataObject::DUnadvise(DWORD /*dwConnection*/) {
	return E_NOTIMPL;
}

HRESULT CImageDataObject::EnumDAdvise(IEnumSTATDATA ** /*ppenumAdvise*/) {
	return E_NOTIMPL;
}

/*
 * Some parts Copyright (C) 2003-2004 createagaga
 * Some parts Copyright (C) 2003-2011 Petr Kozelka, PPK at czdc dot org
 * Licensed under GNU General Public License version 3.
 */
