/*
 * CzDC - client for Direct Connect peer to peer network.

 * Copyright (C) 2002-2003 Trpaslik
 * Copyright (C) 2002-2011 Petr Kozelka, PPK at CzDC dot org

 * CzDC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * CzDC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with CzDC. If not, see <http://www.gnu.org/licenses/>.
 */

//----------------------------------------------------------------------------------------------------------------------------------------------------
#ifndef PROP_PAGE_TEXT_STYLES_H
#define PROP_PAGE_TEXT_STYLES_H
//----------------------------------------------------------------------------------------------------------------------------------------------------
#pragma once
//----------------------------------------------------------------------------------------------------------------------------------------------------
#include "PropPage.h"
//----------------------------------------------------------------------------------------------------------------------------------------------------
#include "../client/ConnectionManager.h"
#include "../client/SettingsManager.h"
//----------------------------------------------------------------------------------------------------------------------------------------------------
#include "ChatCtrl.h"
//----------------------------------------------------------------------------------------------------------------------------------------------------

class PropPageTextStyles: public PropPage {
public:
	PropPageTextStyles(SettingsManager *s);
	~PropPageTextStyles();

	void onInitDialog();
	void onEditBackColor();
	void onEditForeColor();
	void onEditTextStyle();
	void onDefaultStyles();
	void onBlackAndWhite();
	void onClickedText();
	void onEditBackground();
	void onEditError();
	void onEditPaused();
	void OnDestroy();

	// Common PropPage interface
	PROPSHEETPAGE *getPSP() { return &m_psp; }
	void write();
private:
	void RefreshPreview();

    static BOOL CALLBACK TextStylesPageProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	class TextStyleSettings: public CHARFORMAT2 {
	public:
		TextStyleSettings() : settings(NULL), m_iBackColor((SettingsManager::IntSetting)0), m_iForeColor((SettingsManager::IntSetting)0), m_iBold((SettingsManager::IntSetting)0),
            m_iItalic((SettingsManager::IntSetting)0) { };
		~TextStyleSettings() { };

        void Init(HWND hWndParent, SettingsManager *pSM, LPCSTR sText, LPCSTR sPreviewText, SettingsManager::IntSetting iBack,
            SettingsManager::IntSetting iFore, SettingsManager::IntSetting iBold, SettingsManager::IntSetting iItalic);
        void LoadSettings();
        void SaveSettings();
        void EditBackColor();
        void EditForeColor();
        void EditTextStyle();

        string m_sText;
        string m_sPreviewText;

        HWND m_hWndParent;
        SettingsManager *settings;
        SettingsManager::IntSetting m_iBackColor;
        SettingsManager::IntSetting m_iForeColor;
        SettingsManager::IntSetting m_iBold;
        SettingsManager::IntSetting m_iItalic;
    };

	static Item items[];
	static TextItem texts[];
	enum TextStyles { TS_GENERAL, TS_MYNICK, TS_MYMSG, TS_PRIVATE, TS_SYSTEM, TS_SERVER, TS_TIMESTAMP, TS_URL, TS_FAVORITE, TS_OP, TS_LAST };

	TCHAR* title;
	TextStyleSettings TextStyles[TS_LAST];
	ChatCtrl m_Preview;
	LOGFONT m_Font;
	COLORREF m_BackColor;
	COLORREF m_ForeColor;
	COLORREF fg, bg, err, paused;
};
//----------------------------------------------------------------------------------------------------------------------------------------------------

#endif
