/*
 * Copyright (C) 2001-2011 Jacek Sieka, arnetheduck on gmail point com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef PROPERTIES_DLG_H
#define PROPERTIES_DLG_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PropPage.h"

class PropertiesDlg {
public:
	enum { numPages = 17 };

    PROPSHEETHEADER m_psh;

    HWND m_hWnd;

	PropertiesDlg(HWND hWndParent, SettingsManager *s);
	~PropertiesDlg();

	void onInitDialog();
	void onSetCurSel(WPARAM wParam);
	void onSelChanged(LPNMHDR pnmh);
	void write();

    INT_PTR DoModal(HWND hWndParent = ::GetActiveWindow());
private:
	enum {
		SPACE_MID = 5,
		SPACE_TOP = 10,
		SPACE_LEFT = 10,
		SPACE_RIGHT = 10,
		TREE_WIDTH = 150,
	};

	enum {
		MAX_NAME_LENGTH = 256
	};

    HWND hWndTree;

	void hideTab();
	void addTree();
	void fillTree();

	HTREEITEM createTree(const tstring& str, HTREEITEM parent, int page);
	HTREEITEM findItem(const tstring& str, HTREEITEM start);
	HTREEITEM findItem(int page, HTREEITEM start);

	static int CALLBACK PropDlgProc(HWND hwndDlg, UINT uMsg, LPARAM lParam);
	static LRESULT CALLBACK PropDlgWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	static LRESULT CALLBACK TabWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
protected:
	PropPage *pages[numPages];
};

#endif // PROPERTIES_DLG_H

/*
 * Some parts Copyright (C) 2002-2011 Petr Kozelka, PPK at czdc dot org
 * Licensed under GNU General Public License version 3.
 */
