/*
 * CzDC - client for Direct Connect peer to peer network.

 * Copyright (C) 2002-2011 Petr Kozelka, PPK at CzDC dot org

 * CzDC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * CzDC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with CzDC. If not, see <http://www.gnu.org/licenses/>.
 */

//----------------------------------------------------------------------------------------------------------------------------------------------------
#ifndef SEARCH_INFO_H
#define SEARCH_INFO_H
//----------------------------------------------------------------------------------------------------------------------------------------------------
#pragma once
//----------------------------------------------------------------------------------------------------------------------------------------------------
struct RootItem;
class SearchResult;
//----------------------------------------------------------------------------------------------------------------------------------------------------

class SearchInfo {
public:
    enum {
        COLUMN_FILE_NAME,
        COLUMN_HITS_COUNT,
        COLUMN_USER_NICK,
        COLUMN_FILE_TYPE,
        COLUMN_FILE_SIZE,
        COLUMN_FILE_PATH,
        COLUMN_USER_SLOTS,
        COLUMN_USER_CONNECTION,
        COLUMN_USER_HUB,
        COLUMN_FILE_EXACT_SIZE,
        COLUMN_USER_COUNTRY,
        COLUMN_FILE_HASH,
        COLUMN_LAST
    };

    RootItem * pRoot;

    SearchInfo * pNext, *pPrev;

    SearchResult * pSR;

    tstring tsColumns[11];

    uint8_t ui8CountryFlagImage;

    SearchInfo(SearchResult * pSearchResult);
    ~SearchInfo();

    int GetImageIndex();

    const TCHAR * GetText(const int & iColumn) const;

    void Update();

    static int CompareItems(const SearchInfo * pFirst, const SearchInfo * pSecond, const int & iColumn);
};
//----------------------------------------------------------------------------------------------------------------------------------------------------

#endif
