/*
* Based on a class by R. Engels
* http://www.codeproject.com/shell/shellcontextmenu.asp
*/

#ifndef SHELLCONTEXTMENU_H
#define SHELLCONTEXTMENU_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CShellContextMenu {
public:
	CShellContextMenu();
	~CShellContextMenu();

	void SetPath(const tstring& strPath);
	HMENU GetMenu();
	UINT ShowContextMenu(const HWND &hWnd, const int &iX, const int &iY);
private:
	bool bDelete;
	HMENU m_Menu;
	IShellFolder* m_psfFolder;
	LPITEMIDLIST* m_pidlArray;

	void FreePIDLArray(LPITEMIDLIST* pidlArray);
	bool GetContextMenu(LPVOID* ppContextMenu, int& iMenuType);
	void InvokeCommand(LPCONTEXTMENU pContextMenu, UINT idCommand);
	static LRESULT CALLBACK HookWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
};

#endif // !defined(SHELLCONTEXTMENU_H)

/*
 * Some parts Copyright (C) 2002-2011 Petr Kozelka, PPK at czdc dot org
 * Licensed under GNU General Public License version 3.
 */
