/*
 * CzDC - client for Direct Connect peer to peer network.

 * Copyright (C) 2002-2011 Petr Kozelka, PPK at CzDC dot org

 * CzDC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * CzDC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with CzDC. If not, see <http://www.gnu.org/licenses/>.
 */

//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#ifndef UPNP_H
#define UPNP_H
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#pragma once
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

class UPnP {
public:
    string sExternalIP;

	UPnP();
	~UPnP();

    void OnTimer();
	void OpenPorts();
	void ClosePorts();
private:
    enum {
        ACTUAL_ACTION_NONE,
        ACTUAL_ACTION_OPEN_PORTS,
        ACTUAL_ACTION_CLOSE_PORTS
    };

    IUPnPNAT * pUPnPNAT;

    long lSearchPort, lTransferPort;

    uint8_t ui8ActualAction, ui8GetSPMCCount;

	bool bPortsOpened;

    uint8_t Open();
    uint8_t Close();

    IStaticPortMappingCollection * GetSPMC(bool &bTimer);
};

//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
extern UPnP * pUPnP;
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

#endif
