/*
 * CzDC - client for Direct Connect peer to peer network.

 * Copyright (C) 2002-2011 Petr Kozelka, PPK at CzDC dot org

 * CzDC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * CzDC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with CzDC. If not, see <http://www.gnu.org/licenses/>.
 */

//----------------------------------------------------------------------------------------------------------------------------------------------------
#ifndef USER_INFO_H
#define USER_INFO_H
//----------------------------------------------------------------------------------------------------------------------------------------------------
#pragma once
//----------------------------------------------------------------------------------------------------------------------------------------------------
#include "WinUtil.h"
//----------------------------------------------------------------------------------------------------------------------------------------------------

struct UserTask {
	UserTask(const OnlineUser& ou) : user(ou.getUser()), identity(ou.getIdentity()) { }
	
	UserPtr user;
	Identity identity;
};
//----------------------------------------------------------------------------------------------------------------------------------------------------

enum {
	COLUMN_FIRST, 
	COLUMN_NICK = COLUMN_FIRST, 
	COLUMN_SHARED, 
	COLUMN_EXACT_SHARED, 
	COLUMN_DESCRIPTION, 
	COLUMN_TAG,
	COLUMN_CONNECTION, 
	COLUMN_EMAIL, 
	COLUMN_CLIENTID, 
	COLUMN_VERSION, 
	COLUMN_MODE, 
	COLUMN_HUBS, 
	COLUMN_SLOTS, 
	COLUMN_LIMITER, 
	COLUMN_COUNTRY, 
	COLUMN_LAST
};
//----------------------------------------------------------------------------------------------------------------------------------------------------

class UserInfo : public UserInfoBase {
public:
	UserInfo(const UserTask& u, const bool &bOperator, bool bUpdate = true);
	~UserInfo();
	
	const TCHAR* getText(const int &col, TCHAR* buf) const;

	static int compareItems(const UserInfo* a, const UserInfo* b, int col);
	uint8_t imageIndex() {
		return WinUtil::getImage(identity);
	}

	bool update(const Identity& identity, int sortCol, const bool &bOperator);

	string getNick() const { return identity.getNick(); }

	GETSET(Identity, identity, Identity);
private:
	TCHAR* columns[COLUMN_LAST];
};
//----------------------------------------------------------------------------------------------------------------------------------------------------

#endif
