/*
 * CzDC - client for Direct Connect peer to peer network.

 * Copyright (C) 2002-2011 Petr Kozelka, PPK at CzDC dot org

 * CzDC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * CzDC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with CzDC. If not, see <http://www.gnu.org/licenses/>.
 */

//----------------------------------------------------------------------------------------------------------------------------------------------------
#ifndef WIN_API_UTIL_H
#define WIN_API_UTIL_H
//----------------------------------------------------------------------------------------------------------------------------------------------------
#pragma once
//----------------------------------------------------------------------------------------------------------------------------------------------------
extern WNDPROC OldButtonProc;
extern WNDPROC OldComboBoxProc;
extern WNDPROC OldEditProc;
extern WNDPROC OldListViewProc;
extern WNDPROC OldPropertySheetProc;
extern WNDPROC OldRichEditProc;
extern WNDPROC OldStatusBarProc;
extern WNDPROC OldTabControlProc;
extern WNDPROC OldTreeViewProc;
//----------------------------------------------------------------------------------------------------------------------------------------------------

DWORD_PTR TreeGetItemData(const HWND &Tree, const HTREEITEM &hItem);
BOOL TreeGetItemText(const HWND &Tree, const HTREEITEM &hItem, const LPTSTR &lpstrText, const int &iLen);
HTREEITEM TreeInsertItem(const HWND &Tree, const UINT &uiMask, const LPCTSTR &lpszItem, const int &iImage, const int &iSelectedImage, const UINT &uiState,
    const UINT &uiStateMask, const LPARAM &lParam, const HTREEITEM &hParent, const HTREEITEM &hInsertAfter);
BOOL TreeSetItem(const HWND &Tree, const HTREEITEM &hItem, const UINT &uiMask, const LPCTSTR &lpszItem, const int &iImage, const int &iSelectedImage, 
    const UINT &uiState, const UINT &uiStateMask, const LPARAM &lParam);
void TreeGetContextMenuPos(const HWND &Tree, int &iX, int &iY);
//----------------------------------------------------------------------------------------------------------------------------------------------------

void ToolInfoInit(TOOLINFO &ti, const UINT &iFlags, const HWND &hWnd, const UINT &iIDTool, const LPRECT &lpRect, const LPTSTR &lpstrText);
//----------------------------------------------------------------------------------------------------------------------------------------------------

void ListViewInsertDummyColumn(const HWND &List);
int ListViewInsertColumn(const HWND &List, const int &iCol, const LPCTSTR lpszColumnHeading, const int &iFormat, const int &iWidth, const int &iSubItem);
void ListViewSetItem(const HWND &List, const int &iItem, const int &iSubItem, const UINT &uiMask, const LPCTSTR lpszItem, const int &iImage, const DWORD_PTR &i = 0);
DWORD_PTR ListViewGetItem(const HWND &List, const int &i);
void ListViewGetItemText(const HWND &List, const int &iItem, const int &iSubItem, const LPTSTR lpszText, const int &iLen);
void ListViewSelectItem(const HWND &List, const int &iItem);
int ListViewInsertItem(const HWND &List, const UINT &uiMask, const int &iItem, const LPCTSTR lpszItem, const UINT &uiState, const UINT &uiStateMask,
    const int &iImage, const LPARAM lParam);
void ListViewUpdateArrow(const HWND &List, const bool &isAscending, const int &iSortColumn);
void ListViewGetContextMenuPos(const HWND &List, int &iX, int &iY);
//----------------------------------------------------------------------------------------------------------------------------------------------------

void InitializeChooseColor(CHOOSECOLOR &cc, const COLORREF &clr, const HWND &hWndParent);
//----------------------------------------------------------------------------------------------------------------------------------------------------

void RegisterWindowClass(ATOM &aAtom, const WNDPROC &StartWindowProc, const LPCTSTR lpszClassName, const UINT &uiResourceID);
//----------------------------------------------------------------------------------------------------------------------------------------------------

void CenterWindow(HWND hWnd, HWND hWndParent);
//----------------------------------------------------------------------------------------------------------------------------------------------------

#endif
